diff --git a/src/backend/access/transam/slru.c b/src/backend/access/transam/slru.c
index 8429caaa80a..71ac70fb40c 100644
--- a/src/backend/access/transam/slru.c
+++ b/src/backend/access/transam/slru.c
@@ -426,295 +1584,32 @@ SlruScanDirectory(Oid rel_id, SlruPagePrecedesFunction PagePrecedes,
 	return retval;
 }
 
-
-void
-CheckPointSLRU(void)
-{
-	/* Ensure that directory entries for new files are on disk. */
-	for (int i = 0; i < lengthof(defs); ++i)
-	{
-		if (defs[i].synchronize)
-			fsync_fname(defs[i].path, true);
-	}
-}
-
-/*
- * Read a buffer.  Buffer is pinned on return.
- */
-Buffer
-ReadSlruBuffer(Oid rel_id, int pageno)
-{
-	RelFileLocator rlocator = SlruRelFileLocator(rel_id);
-	Buffer buffer;
-	bool hit;
-
-	/* Try to avoid doing a buffer mapping table lookup for repeated access. */
-	buffer = slru_recent_buffers[rel_id].recent_buffer;
-	if (slru_recent_buffers[rel_id].pageno == pageno &&
-		BufferIsValid(buffer) &&
-		ReadRecentBuffer(rlocator, MAIN_FORKNUM, pageno, buffer))
-	{
-		pgstat_count_slru_page_hit(rel_id);
-		return buffer;
-	}
-
-	/* Regular lookup. */
-	buffer = ReadBufferWithoutRelcacheWithHit(rlocator, MAIN_FORKNUM, pageno,
-											  RBM_NORMAL, &hit);
-
-	/* Remember where this page is for next time. */
-	slru_recent_buffers[rel_id].pageno = pageno;
-	slru_recent_buffers[rel_id].recent_buffer = buffer;
-
-	if (hit)
-		pgstat_count_slru_page_hit(rel_id);
-
-	return buffer;
-}
-
 /*
- * Zero-initialize a buffer.  Buffer is pinned and exclusively locked on return.
+ * Individual SLRUs (clog, ...) have to provide a sync.c handler function so
+ * that they can provide the correct "SlruCtl" (otherwise we don't know how to
+ * build the path), but they just forward to this common implementation that
+ * performs the fsync.
  */
-Buffer
-ZeroSlruBuffer(Oid rel_id, int pageno)
-{
-	RelFileLocator rlocator = SlruRelFileLocator(rel_id);
-	Buffer buffer;
-
-	buffer = ReadBufferWithoutRelcache(rlocator, MAIN_FORKNUM, pageno,
-									   RBM_ZERO_AND_LOCK, NULL, true);
-
-	/* Remember where this page is for next time. */
-	slru_recent_buffers[rel_id].pageno = pageno;
-	slru_recent_buffers[rel_id].recent_buffer = buffer;
-
-	pgstat_count_slru_page_zeroed(rel_id);
-
-	return buffer;
-}
-
-Oid
-SlruRelIdByName(const char *name)
-{
-	for (int i = 0; i < lengthof(defs); ++i)
-		if (strcmp(defs[i].name, name) == 0)
-			return i;
-
-	elog(ERROR, "unknown SLRU \"%s\"", name);
-}
-
-const char *
-SlruName(Oid rel_id)
-{
-	if (rel_id >= SLRU_NUM_RELS)
-		elog(ERROR, "invalid SLRU rel ID %u", rel_id);
-
-	return defs[rel_id].name;
-}
-
 int
-slrusyncfiletag(const FileTag *ftag, char *path)
-{
-	SMgrRelation reln;
-	File		file;
-
-	reln = smgropen(ftag->rlocator, InvalidBackendId);
-	file = slrufile(reln, ftag->segno * SLRU_PAGES_PER_SEGMENT, O_RDWR, true);
-	if (file < 0)
-	{
-		/* Path is reported here so the caller can make an error message */
-		SlruFileName(ftag->rlocator.relNumber, path, ftag->segno);
-		return -1;
-	}
-
-	pgstat_count_slru_flush(reln->smgr_rlocator.locator.relNumber);
-
-	return FileSync(file, WAIT_EVENT_SLRU_SYNC);
-}
-
-static File
-slrufile(SMgrRelation reln, BlockNumber blocknum, int mode, bool missing_ok)
-{
-	int segment = blocknum / SLRU_PAGES_PER_SEGMENT;
-	char path[MAXPGPATH];
-
-	Assert(reln->smgr_rlocator.locator.dbOid == SLRU_DB_ID);
-	Assert(reln->smgr_rlocator.locator.relNumber < lengthof(defs));
-	Assert(defs[reln->smgr_rlocator.locator.relNumber].path != NULL);
-
-	/* Do we have the right file open already? */
-	if (reln->slru_file_segment == segment)
-	{
-		/* XXX How can we invalidate this if the SLRU wraps around?! */
-		Assert(reln->slru_file != -1);
-		return reln->slru_file;
-	}
-
-	/* Close the current file, if we have one open. */
-	if (reln->slru_file_segment != -1)
-	{
-		Assert(reln->slru_file != -1);
-		FileClose(reln->slru_file);
-		reln->slru_file = -1;
-		reln->slru_file_segment = -1;
-	}
-
-	/* Open the file we want. */
-	SlruFileName(reln->smgr_rlocator.locator.relNumber, path, segment);
-	reln->slru_file = PathNameOpenFile(path, mode);
-	if (reln->slru_file >= 0)
-		reln->slru_file_segment = segment;
-	else if (!(missing_ok && errno == ENOENT))
-		ereport(ERROR,
-				(errcode_for_file_access(),
-				 errmsg("could not open file \"%s\": %m",
-						path)));
-
-	/*
-	 * XXX That error message doesn't contain the xid; then again, the
-	 * previous SLRU error codes were all weird about xids anyway; maybe
-	 * clog.c, notify.c et al should set a context that has SLRU-specific
-	 * context in a more natural format
-	 */
-
-	return reln->slru_file;
-}
-
-void
-slruopen(SMgrRelation reln)
+SlruSyncFileTag(SlruCtl ctl, const FileTag *ftag, char *path)
 {
-	reln->slru_file = -1;
-	reln->slru_file_segment = -1;
+	int			fd;
+	int			save_errno;
+	int			result;
 
-	/*
-	 * We don't want this to be closed at end of transaction, which would
-	 * otherwise happen, because it isn't owned by a Relation.
-	 */
-	dlist_delete(&reln->node);
-}
-
-void
-slruclose(SMgrRelation reln, ForkNumber forknum)
-{
-	if (reln->slru_file != -1)
-		FileClose(reln->slru_file);
-	reln->slru_file = -1;
-	reln->slru_file_segment = -1;
-}
-
-void
-slruwrite(SMgrRelation reln, ForkNumber forknum, BlockNumber blocknum,
-		  char *buffer, bool skipFsync)
-{
-	File file;
-	Oid	rel_id;
-	off_t offset;
-	int rc;
-
-	file = slrufile(reln, blocknum, O_RDWR | O_CREAT, false);
-	offset = (blocknum % SLRU_PAGES_PER_SEGMENT) * BLCKSZ;
-
-	rc = FileWrite(file, buffer, BLCKSZ, offset, WAIT_EVENT_SLRU_WRITE);
-	if (rc < 0)
-		ereport(ERROR,
-				(errcode_for_file_access(),
-				 errmsg("could not write %d bytes to file \"%s\" at offset %d: %m",
-						BLCKSZ,
-						FilePathName(file),
-						(int) offset)));
-	if (rc < BLCKSZ)
-		ereport(ERROR,
-				(errcode_for_file_access(),
-				 errmsg("could not write %d bytes to file \"%s\" at offset %d, only %d bytes written",
-						BLCKSZ,
-						FilePathName(file),
-						(int) offset,
-						rc)));
-
-	rel_id = reln->smgr_rlocator.locator.relNumber;
-	if (defs[rel_id].synchronize)
-	{
-		FileTag			tag;
-
-		/* Tell checkpointer to synchronize this file. */
-		INIT_SLRUFILETAG(tag, rel_id, blocknum / SLRU_PAGES_PER_SEGMENT);
-		if (!RegisterSyncRequest(&tag, SYNC_REQUEST, false))
-		{
-			/* Queue full.  Do it synchronously. */
-			if (FileSync(file, WAIT_EVENT_SLRU_SYNC) < 0)
-				ereport(data_sync_elevel(ERROR),
-						(errcode_for_file_access(),
-						 errmsg("could not synchronize file \"%s\": %m",
-								FilePathName(file))));
-		}
-	}
+	SlruFileName(ctl, path, ftag->segno);
 
-	pgstat_count_slru_page_written(reln->smgr_rlocator.locator.relNumber);
-}
-
-void
-slruread(SMgrRelation reln, ForkNumber forknum, BlockNumber blocknum,
-		 char *buffer)
-{
-	File file;
-	off_t offset;
-	int rc;
-
-	file = slrufile(reln, blocknum, O_RDWR, false);
-	offset = (blocknum % SLRU_PAGES_PER_SEGMENT) * BLCKSZ;
-
-	rc = FileRead(file, buffer, BLCKSZ, offset, WAIT_EVENT_SLRU_READ);
-	if (rc < 0)
-		ereport(ERROR,
-				(errcode_for_file_access(),
-				 errmsg("could not read %d bytes from file \"%s\" at offset %d: %m",
-						BLCKSZ,
-						FilePathName(file),
-						(int) offset)));
-	if (rc < BLCKSZ)
-		ereport(ERROR,
-				(errcode_for_file_access(),
-				 errmsg("could not read %d bytes from file \"%s\" at offset %d, only %d bytes read",
-						BLCKSZ,
-						FilePathName(file),
-						(int) offset,
-						rc)));
-
-	pgstat_count_slru_page_read(reln->smgr_rlocator.locator.relNumber);
-}
+	fd = OpenTransientFile(path, O_RDWR | PG_BINARY);
+	if (fd < 0)
+		return -1;
 
-void
-slruwriteback(SMgrRelation reln, ForkNumber forknum,
-			  BlockNumber blocknum, BlockNumber nblocks)
-{
-	Oid rel_id;
+	pgstat_report_wait_start(WAIT_EVENT_SLRU_FLUSH_SYNC);
+	result = pg_fsync(fd);
+	pgstat_report_wait_end();
+	save_errno = errno;
 
-	/* No point in flushing data we won't be fsyncing. */
-	rel_id = reln->smgr_rlocator.locator.relNumber;
-	if (!defs[rel_id].synchronize)
-		return;
+	CloseTransientFile(fd);
 
-	while (nblocks > 0)
-	{
-		File		file;
-		BlockNumber blocknum_in_this_file;
-		BlockNumber nflush;
-
-		/* File range of blocks to flush in one file. */
-		blocknum_in_this_file = blocknum % SLRU_PAGES_PER_SEGMENT;
-		nflush = Min(nblocks, SLRU_PAGES_PER_SEGMENT - blocknum_in_this_file);
-
-		/* The file might have been unlinked already, so tolerate missing. */
-		file = slrufile(reln, blocknum, O_RDWR, true);
-		if (file < 0)
-			return;
-
-		FileWriteback(file,
-					  BLCKSZ * blocknum_in_this_file,
-					  BLCKSZ * nflush,
-					  WAIT_EVENT_SLRU_FLUSH);
-
-		nblocks -= nflush;
-		blocknum += nflush;
-	}
+	errno = save_errno;
+	return result;
 }
diff --git a/src/backend/access/transam/subtrans.c b/src/backend/access/transam/subtrans.c
index 90cc1318526..635e5368cd6 100644
--- a/src/backend/access/transam/subtrans.c
+++ b/src/backend/access/transam/subtrans.c
@@ -29,6 +29,7 @@
 #include "postgres.h"
 
 #include "access/slru.h"
+#include "access/nrel.h"
 #include "access/subtrans.h"
 #include "access/transam.h"
 #include "pg_trace.h"
@@ -74,7 +75,8 @@ SubTransSetParent(TransactionId xid, TransactionId parent)
 	Assert(TransactionIdIsValid(parent));
 	Assert(TransactionIdFollows(xid, parent));
 
-	buffer = ReadSlruBuffer(SLRU_SUBTRANS_REL_ID, pageno);
+	buffer = ReadNrelBuffer(NREL_SUBTRANS_REL_ID, pageno);
+
 	LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
 	ptr = (TransactionId *) BufferGetPage(buffer);
 	ptr += entryno;
@@ -113,7 +115,8 @@ SubTransGetParent(TransactionId xid)
 	if (!TransactionIdIsNormal(xid))
 		return InvalidTransactionId;
 
-	buffer = ReadSlruBuffer(SLRU_SUBTRANS_REL_ID, pageno);
+	buffer = ReadNrelBuffer(NREL_SUBTRANS_REL_ID, pageno);
+
 
 	ptr = (TransactionId *) BufferGetPage(buffer);
 	ptr += entryno;
@@ -183,7 +186,7 @@ BootStrapSUBTRANS(void)
 {
 	Buffer		buffer;
 
-	SlruPagePrecedesUnitTests(SubTransPagePrecedes, SUBTRANS_XACTS_PER_PAGE);
+	NrelPagePrecedesUnitTests(SubTransPagePrecedes, SUBTRANS_XACTS_PER_PAGE);
 
 	/* Create and zero the first page of the subtrans log */
 	buffer = ZeroSUBTRANSPage(0);
@@ -206,7 +209,8 @@ ZeroSUBTRANSPage(int pageno)
 {
 	Buffer		buffer;
 
-	buffer = ZeroSlruBuffer(SLRU_SUBTRANS_REL_ID, pageno);
+	buffer = ZeroNrelBuffer(NREL_SUBTRANS_REL_ID, pageno);
+
 	MarkBufferDirty(buffer);
 
 	return buffer;
@@ -289,16 +293,16 @@ TruncateSUBTRANS(TransactionId oldestXact)
 
 	/*
 	 * The cutoff point is the start of the segment containing oldestXact. We
-	 * pass the *page* containing oldestXact to SimpleLruTruncate.  We step
+	 * pass the *page* containing oldestXact to NonRelTruncate.  We step
 	 * back one transaction to avoid passing a cutoff page that hasn't been
 	 * created yet in the rare case that oldestXact would be the first item on
 	 * a page and oldestXact == next XID.  In that case, if we didn't subtract
-	 * one, we'd trigger SimpleLruTruncate's wraparound detection.
+	 * one, we'd trigger NonRelTruncate's wraparound detection.
 	 */
 	TransactionIdRetreat(oldestXact);
 	cutoffPage = TransactionIdToPage(oldestXact);
 
-	SimpleLruTruncate(SLRU_SUBTRANS_REL_ID, SubTransPagePrecedes, cutoffPage);
+	NonRelTruncate(NREL_SUBTRANS_REL_ID, SubTransPagePrecedes, cutoffPage);
 }
 
 
diff --git a/src/backend/access/transam/xlog.c b/src/backend/access/transam/xlog.c
index 901a42e93f1..f01a14c8b80 100644
--- a/src/backend/access/transam/xlog.c
+++ b/src/backend/access/transam/xlog.c
@@ -7037,7 +7037,7 @@ CheckPointGuts(XLogRecPtr checkPointRedo, int flags)
 	CheckPointLogicalRewriteHeap();
 	CheckPointReplicationOrigin();
 	CheckPointPredicate();
-	CheckPointSLRU();
+	CheckPointNREL();
 
 	/* Write out all dirty data in the buffer pool */
 	TRACE_POSTGRESQL_BUFFER_CHECKPOINT_START(flags);
diff --git a/src/backend/commands/async.c b/src/backend/commands/async.c
index c595fee8018..723cf8f6e1c 100644
--- a/src/backend/commands/async.c
+++ b/src/backend/commands/async.c
@@ -131,6 +131,7 @@
 #include <signal.h>
 
 #include "access/parallel.h"
+#include "access/nrel.h"
 #include "access/slru.h"
 #include "access/transam.h"
 #include "access/xact.h"
@@ -312,7 +313,7 @@ static AsyncQueueControl *asyncQueueControl;
 /*
  * Use segments 0000 through FFFF.  Each contains SLRU_PAGES_PER_SEGMENT pages
  * which gives us the pages from 0 to SLRU_PAGES_PER_SEGMENT * 0x10000 - 1.
- * We could use as many segments as SlruScanDirectory() allows, but this gives
+ * We could use as many segments as NrelScanDirectory() allows, but this gives
  * us so much space already that it doesn't seem worth the trouble.
  *
  * The most data we can have in the queue at a time is QUEUE_MAX_PAGE/2
@@ -563,8 +564,8 @@ AsyncShmemInit(void)
 		/*
 		 * During start or reboot, clean out the pg_notify directory.
 		 */
-		(void) SlruScanDirectory(SLRU_NOTIFY_REL_ID, asyncQueuePagePrecedes,
-								 SlruScanDirCbDeleteAll, NULL);
+		(void) NrelScanDirectory(NREL_NOTIFY_REL_ID, asyncQueuePagePrecedes,
+								 NrelScanDirCbDeleteAll, NULL);
 	}
 }
 
@@ -1423,11 +1424,12 @@ asyncQueueAddEntries(ListCell *nextNotify)
 	pageno = QUEUE_POS_PAGE(queue_head);
 	if (QUEUE_POS_IS_ZERO(queue_head))
 	{
-		buffer = ZeroSlruBuffer(SLRU_NOTIFY_REL_ID, pageno);
+		buffer = ZeroNrelBuffer(NREL_NOTIFY_REL_ID, pageno);
 	}
 	else
 	{
-		buffer = ReadSlruBuffer(SLRU_NOTIFY_REL_ID, pageno);
+		buffer = ReadNrelBuffer(NREL_NOTIFY_REL_ID, pageno);
+
 		LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
 	}
 
@@ -1474,12 +1476,12 @@ asyncQueueAddEntries(ListCell *nextNotify)
 			 * Page is full, so we're done here, but first fill the next page
 			 * with zeroes.  The reason to do this is to ensure that slru.c's
 			 * idea of the head page is always the same as ours, which avoids
-			 * boundary problems in SimpleLruTruncate.  The test in
+			 * boundary problems in NonRelTruncate.  The test in
 			 * asyncQueueIsFull() ensured that there is room to create this
 			 * page without overrunning the queue.
 			 */
 			UnlockReleaseBuffer(buffer);
-			buffer = ZeroSlruBuffer(SLRU_NOTIFY_REL_ID,
+			buffer = ZeroNrelBuffer(NREL_NOTIFY_REL_ID,
 									QUEUE_POS_PAGE(queue_head));
 			MarkBufferDirty(buffer);
 
@@ -1981,7 +1983,8 @@ asyncQueueReadAllNotifications(void)
 			 * transmitting them to our frontend.  Copy only the part of the
 			 * page we will actually inspect.
 			 */
-			buffer = ReadSlruBuffer(SLRU_NOTIFY_REL_ID, curpage);
+			buffer = ReadNrelBuffer(NREL_NOTIFY_REL_ID, curpage);
+
 			if (curpage == QUEUE_POS_PAGE(head))
 			{
 				/* we only want to read as far as head */
@@ -2148,7 +2151,7 @@ asyncQueueAdvanceTail(void)
 	int			newtailpage;
 	int			boundary;
 
-	/* Restrict task to one backend per cluster; see SimpleLruTruncate(). */
+	/* Restrict task to one backend per cluster; see NonRelTruncate(). */
 	LWLockAcquire(NotifyQueueTailLock, LW_EXCLUSIVE);
 
 	/*
@@ -2165,7 +2168,7 @@ asyncQueueAdvanceTail(void)
 	 * there are pages we can truncate but haven't yet finished doing so.
 	 *
 	 * For concurrency's sake, we don't want to hold NotifyQueueLock while
-	 * performing SimpleLruTruncate.  This is OK because no backend will try
+	 * performing NonRelTruncate.  This is OK because no backend will try
 	 * to access the pages we are in the midst of truncating.
 	 */
 	LWLockAcquire(NotifyQueueLock, LW_EXCLUSIVE);
@@ -2191,10 +2194,10 @@ asyncQueueAdvanceTail(void)
 	if (asyncQueuePagePrecedes(oldtailpage, boundary))
 	{
 		/*
-		 * SimpleLruTruncate() will ask for NotifySLRULock but will also
+		 * NonRelTruncate() will ask for NotifySLRULock but will also
 		 * release the lock again.
 		 */
-		SimpleLruTruncate(SLRU_NOTIFY_REL_ID, asyncQueuePagePrecedes, newtailpage);
+		NonRelTruncate(NREL_NOTIFY_REL_ID, asyncQueuePagePrecedes, newtailpage);
 
 		/*
 		 * Update QUEUE_STOP_PAGE.  This changes asyncQueueIsFull()'s verdict
diff --git a/src/backend/storage/lmgr/predicate.c b/src/backend/storage/lmgr/predicate.c
index 690d1d1401a..2177386ca50 100644
--- a/src/backend/storage/lmgr/predicate.c
+++ b/src/backend/storage/lmgr/predicate.c
@@ -193,6 +193,7 @@
 #include "postgres.h"
 
 #include "access/parallel.h"
+#include "access/nrel.h"
 #include "access/slru.h"
 #include "access/subtrans.h"
 #include "access/transam.h"
@@ -798,7 +799,7 @@ SerialInit(void)
 #ifdef USE_ASSERT_CHECKING
 	SerialPagePrecedesLogicallyUnitTests();
 #endif
-	SlruPagePrecedesUnitTests(SerialPagePrecedesLogically, SERIAL_ENTRIESPERPAGE);
+	NrelPagePrecedesUnitTests(SerialPagePrecedesLogically, SERIAL_ENTRIESPERPAGE);
 
 	/*
 	 * Create or attach to the SerialControl structure.
@@ -875,16 +876,18 @@ SerialAdd(TransactionId xid, SerCommitSeqNo minConflictCommitSeqNo)
 		/* Initialize intervening pages. */
 		while (firstZeroPage != targetPage)
 		{
-			buffer = ZeroSlruBuffer(SLRU_SERIAL_REL_ID, firstZeroPage);
+			buffer = ZeroNrelBuffer(NREL_SERIAL_REL_ID, firstZeroPage);
+
 			MarkBufferDirty(buffer);
 			UnlockReleaseBuffer(buffer);
 			firstZeroPage = SerialNextPage(firstZeroPage);
 		}
-		buffer = ZeroSlruBuffer(SLRU_SERIAL_REL_ID, targetPage);
+		buffer = ZeroNrelBuffer(NREL_SERIAL_REL_ID, targetPage);
 	}
 	else
 	{
-		buffer = ReadSlruBuffer(SLRU_SERIAL_REL_ID, targetPage);
+		buffer = ReadNrelBuffer(NREL_SERIAL_REL_ID, targetPage);
+
 		LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
 	}
 
@@ -928,7 +931,8 @@ SerialGetMinConflictCommitSeqNo(TransactionId xid)
 	 * The following function must be called without holding SerialSLRULock,
 	 * but will return with that lock held, which must then be released.
 	 */
-	buffer = ReadSlruBuffer(SLRU_SERIAL_REL_ID, SerialPage(xid));
+	buffer = ReadNrelBuffer(NREL_SERIAL_REL_ID, SerialPage(xid));
+
 	val = SerialValue(buffer, xid);
 	ReleaseBuffer(buffer);
 	LWLockRelease(SerialSLRULock);
@@ -1049,7 +1053,7 @@ CheckPointPredicate(void)
 	LWLockRelease(SerialSLRULock);
 
 	/* Truncate away pages that are no longer required */
-	SimpleLruTruncate(SLRU_SERIAL_REL_ID, SerialPagePrecedesLogically, tailPage);
+	NonRelTruncate(NREL_SERIAL_REL_ID, SerialPagePrecedesLogically, tailPage);
 }
 
 /*------------------------------------------------------------------------*/
diff --git a/src/backend/storage/smgr/smgr.c b/src/backend/storage/smgr/smgr.c
index 3e9f70d1766..88aeeb7b13a 100644
--- a/src/backend/storage/smgr/smgr.c
+++ b/src/backend/storage/smgr/smgr.c
@@ -17,6 +17,7 @@
  */
 #include "postgres.h"
 
+#include "access/nrel.h"
 #include "access/slru.h"
 #include "access/xlogutils.h"
 #include "lib/ilist.h"
@@ -27,6 +28,7 @@
 #include "storage/smgr.h"
 #include "utils/hsearch.h"
 #include "utils/inval.h"
+#include "miscadmin.h"
 
 
 /*
@@ -88,13 +90,13 @@ static const f_smgr smgrsw[] = {
 		.smgr_truncate = mdtruncate,
 		.smgr_immedsync = mdimmedsync,
 	},
-	/* "SLRU" storage */
+	/* "NREL" storage */
 	{
-		.smgr_open = slruopen,
-		.smgr_close = slruclose,
-		.smgr_read = slruread,
-		.smgr_write = slruwrite,
-		.smgr_writeback = slruwriteback,
+		.smgr_open = nrelopen,
+		.smgr_close = nrelclose,
+		.smgr_read = nrelread,
+		.smgr_write = nrelwrite,
+		.smgr_writeback = nrelwriteback,
 	}
 };
 
@@ -177,9 +179,11 @@ smgropen(RelFileLocator rlocator, BackendId backend)
 	/* Look up or create an entry */
 	brlocator.locator = rlocator;
 	brlocator.backend = backend;
+	
 	reln = (SMgrRelation) hash_search(SMgrRelationHash,
-									  &brlocator,
-									  HASH_ENTER, &found);
+								  &brlocator,
+								  HASH_ENTER, &found);
+
 
 	/* Initialize it if not present before */
 	if (!found)
@@ -191,7 +195,7 @@ smgropen(RelFileLocator rlocator, BackendId backend)
 			reln->smgr_cached_nblocks[i] = InvalidBlockNumber;
 
 		/* XXX find some elegant way to do this, or something better */
-		if (rlocator.dbOid == SLRU_DB_ID)
+		if (rlocator.dbOid == NREL_DB_ID)
 			reln->smgr_which = 1;	/* slru.c */
 		else
 			reln->smgr_which = 0;	/* md.c */
diff --git a/src/backend/storage/sync/sync.c b/src/backend/storage/sync/sync.c
index bbabb6b8f51..f04fb2ffbf1 100644
--- a/src/backend/storage/sync/sync.c
+++ b/src/backend/storage/sync/sync.c
@@ -18,6 +18,7 @@
 #include <fcntl.h>
 #include <sys/file.h>
 
+#include "access/nrel.h"
 #include "access/slru.h"
 #include "access/xlog.h"
 #include "access/xlogutils.h"
@@ -103,8 +104,8 @@ static const SyncOps syncsw[] = {
 		.sync_filetagmatches = mdfiletagmatches
 	},
 	/* SLRU */
-	[SYNC_HANDLER_SLRU] = {
-		.sync_syncfiletag = slrusyncfiletag
+	[SYNC_HANDLER_NREL] = {
+		.sync_syncfiletag = nrelsyncfiletag
 	}
 };
 
diff --git a/src/backend/utils/activity/pgstat_slru.c b/src/backend/utils/activity/pgstat_slru.c
index 30ccf36abe7..03532223ef2 100644
--- a/src/backend/utils/activity/pgstat_slru.c
+++ b/src/backend/utils/activity/pgstat_slru.c
@@ -31,7 +31,7 @@ static void pgstat_reset_slru_counter_internal(int index, TimestampTz ts);
  * SLRU counters are reported within critical sections so we use static memory
  * in order to avoid memory allocation.
  */
-static PgStat_SLRUStats pending_SLRUStats[SLRU_NUM_RELS];
+static PgStat_SLRUStats pending_SLRUStats[NREL_NUM_RELS + 1];
 bool		have_slrustats = false;
 
 
@@ -115,7 +115,7 @@ pgstat_fetch_slru(void)
 const char *
 pgstat_get_slru_name(int slru_idx)
 {
-	return SlruName(slru_idx);
+	return NrelName(slru_idx);
 }
 
 /*
@@ -124,7 +124,7 @@ pgstat_get_slru_name(int slru_idx)
 int
 pgstat_get_slru_index(const char *name)
 {
-	return SlruRelIdByName(name);
+	return NrelRelIdByName(name);
 }
 
 /*
@@ -150,7 +150,7 @@ pgstat_slru_flush(bool nowait)
 	else if (!LWLockConditionalAcquire(&stats_shmem->lock, LW_EXCLUSIVE))
 		return true;
 
-	for (i = 0; i < SLRU_NUM_RELS; i++)
+	for (i = 0; i < NREL_NUM_RELS + 1; i++)
 	{
 		PgStat_SLRUStats *sharedent = &stats_shmem->stats[i];
 		PgStat_SLRUStats *pendingent = &pending_SLRUStats[i];
@@ -179,7 +179,7 @@ pgstat_slru_flush(bool nowait)
 void
 pgstat_slru_reset_all_cb(TimestampTz ts)
 {
-	for (int i = 0; i < SLRU_NUM_RELS; i++)
+	for (int i = 0; i < NREL_NUM_RELS + 1; i++)
 		pgstat_reset_slru_counter_internal(i, ts);
 }
 
@@ -210,7 +210,7 @@ get_slru_entry(int slru_idx)
 	 */
 	Assert(IsUnderPostmaster || !IsPostmasterEnvironment);
 
-	Assert((slru_idx >= 0) && (slru_idx < SLRU_NUM_RELS));
+	Assert((slru_idx >= 0) && (slru_idx < NREL_NUM_RELS + 1));
 
 	have_slrustats = true;
 
diff --git a/src/backend/utils/adt/pgstatfuncs.c b/src/backend/utils/adt/pgstatfuncs.c
index d8f383b8631..d01b913d59d 100644
--- a/src/backend/utils/adt/pgstatfuncs.c
+++ b/src/backend/utils/adt/pgstatfuncs.c
@@ -15,6 +15,7 @@
 #include "postgres.h"
 
 #include "access/htup_details.h"
+#include "access/nrel.h"
 #include "access/slru.h"
 #include "access/xlog.h"
 #include "access/xlogprefetcher.h"
@@ -1521,30 +1522,30 @@ pg_stat_get_wal(PG_FUNCTION_ARGS)
 }
 
 /*
- * Returns statistics of SLRU caches.
+ * Returns statistics of NREL caches.
  */
 Datum
 pg_stat_get_slru(PG_FUNCTION_ARGS)
 {
-#define PG_STAT_GET_SLRU_COLS	9
+#define PG_STAT_GET_NREL_COLS	9
 	ReturnSetInfo *rsinfo = (ReturnSetInfo *) fcinfo->resultinfo;
 	int			i;
 	PgStat_SLRUStats *stats;
 
 	InitMaterializedSRF(fcinfo, 0);
 
-	/* request SLRU stats from the cumulative stats system */
+	/* request NREL stats from the cumulative stats system */
 	stats = pgstat_fetch_slru();
 
-	for (i = 0; i < SLRU_NUM_RELS; i++)
+	for (i = 0; i < NREL_NUM_RELS; i++)
 	{
 		/* for each row */
-		Datum		values[PG_STAT_GET_SLRU_COLS] = {0};
-		bool		nulls[PG_STAT_GET_SLRU_COLS] = {0};
+		Datum		values[PG_STAT_GET_NREL_COLS] = {0};
+		bool		nulls[PG_STAT_GET_NREL_COLS] = {0};
 		PgStat_SLRUStats stat;
 		const char *name;
 
-		name = SlruName(i);
+		name = NrelName(i);
 
 		stat = stats[i];
 
diff --git a/src/include/access/nrel.h b/src/include/access/nrel.h
new file mode 100644
index 00000000000..3c2a6e32bdf
--- /dev/null
+++ b/src/include/access/nrel.h
@@ -0,0 +1,112 @@
+/*-------------------------------------------------------------------------
+ *
+ * nrel.h
+ *		Buffering for transaction status logfiles
+ *
+ * Portions Copyright (c) 1996-2023, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/access/nrel.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef NREL_H
+#define NREL_H
+
+#include "access/xlogdefs.h"
+#include "catalog/pg_tablespace_d.h"
+#include "storage/buf.h"
+#include "storage/bufmgr.h"
+#include "storage/lwlock.h"
+#include "storage/smgr.h"
+#include "storage/sync.h"
+
+/* Pseudo database ID used for NREL data. */
+#define NREL_DB_ID 9
+
+/* Pseudo relation IDs used by each cache. */
+#define NREL_CLOG_REL_ID 0 
+#define NREL_MULTIXACT_OFFSET_REL_ID 1 
+#define NREL_MULTIXACT_MEMBER_REL_ID 2 
+#define NREL_SUBTRANS_REL_ID 3
+#define NREL_COMMITTS_REL_ID 4 
+#define NREL_SERIAL_REL_ID 5 
+#define NREL_NOTIFY_REL_ID 6 
+#define NREL_NUM_RELS 7 
+
+typedef bool (*NrelPagePrecedesFunction) (int, int);
+
+static inline RelFileLocator
+NrelRelFileLocator(RelFileNumber relFileNumber)
+{
+	RelFileLocator rlocator = {DEFAULTTABLESPACE_OID, NREL_DB_ID, relFileNumber};
+	return rlocator;
+}
+
+
+/*
+ * Define NREL segment size.  A page is the same BLCKSZ as is used everywhere
+ * else in Postgres.  The segment size can be chosen somewhat arbitrarily;
+ * we make it 32 pages by default, or 256Kb, i.e. 1M transactions for CLOG
+ * or 64K transactions for SUBTRANS.
+ *
+ * Note: because TransactionIds are 32 bits and wrap around at 0xFFFFFFFF,
+ * page numbering also wraps around at 0xFFFFFFFF/xxxx_XACTS_PER_PAGE (where
+ * xxxx is CLOG or SUBTRANS, respectively), and segment numbering at
+ * 0xFFFFFFFF/xxxx_XACTS_PER_PAGE/NREL_PAGES_PER_SEGMENT.  We need
+ * take no explicit notice of that fact in nrel.c, except when comparing
+ * segment and page numbers in NonRelTruncate (see PagePrecedes()).
+ */
+#define NREL_PAGES_PER_SEGMENT	32
+
+#ifdef USE_ASSERT_CHECKING
+extern void NrelPagePrecedesUnitTests(NrelPagePrecedesFunction PagePrecedes,
+									  int per_page);
+#else
+#define NrelPagePrecedesUnitTests(ctl, per_page) do {} while (0)
+#endif
+extern void NonRelTruncate(Oid rel_id, NrelPagePrecedesFunction PagePrecedes,
+							  int cutoffPage);
+extern bool NonRelDoesPhysicalPageExist(Oid rel_id, int pageno);
+
+typedef bool (*NrelScanCallback) (Oid rel_id,
+								  NrelPagePrecedesFunction PagePrecedes,
+								  char *filename, int segpage,
+								  void *data);
+extern bool NrelScanDirectory(Oid rel_id, NrelPagePrecedesFunction PagePrecedes,
+							  NrelScanCallback callback, void *data);
+extern void NrelDeleteSegment(Oid rel_id, int segno);
+
+/* NrelScanDirectory public callbacks */
+extern bool NrelScanDirCbReportPresence(Oid rel_id,
+										NrelPagePrecedesFunction PagePrecedes,
+										char *filename,
+										int segpage, void *data);
+extern bool NrelScanDirCbDeleteAll(Oid rel_id, NrelPagePrecedesFunction PagePrecedes,
+								   char *filename, int segpage,
+								   void *data);
+
+extern void CheckPointNREL(void);
+
+/* Buffer access */
+extern Buffer ReadNrelBuffer(Oid rel_id, int pageno);
+extern Buffer ZeroNrelBuffer(Oid rel_id, int pageno);
+
+/* Interfaces use by stats view */
+extern Oid NrelRelIdByName(const char *name);
+extern const char *NrelName(Oid rel_id);
+
+/* Sync callback */
+extern int	nrelsyncfiletag(const FileTag *ftag, char *path);
+
+/* SMGR callbacks */
+extern void nrelopen(SMgrRelation reln);
+extern void nrelclose(SMgrRelation reln, ForkNumber forknum);
+extern void nrelread(SMgrRelation reln, ForkNumber forknum,
+					 BlockNumber blocknum, char *buffer);
+extern void nrelwrite(SMgrRelation reln, ForkNumber forknum,
+					  BlockNumber blocknum, char *buffer, bool skipFsync);
+extern void nrelwriteback(SMgrRelation reln, ForkNumber forknum,
+						  BlockNumber blocknum, BlockNumber nblocks);
+
+#endif							/* NREL_H */
